//+------------------------------------------------------------------+
//|                                   ATR_1005phillip_2011.02.15.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

// This indicator has been modified to the ATR based on the so-called smoothed-average method instead of the simple-moving average
// See: http://forum.mql4.com/38874

#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
//---- input parameters
extern int AtrPeriod=14;
//---- buffers
double AtrBuffer[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(2);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,AtrBuffer);
   SetIndexBuffer(1,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="ATR("+AtrPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,AtrPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=AtrPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=AtrPeriod;i++) AtrBuffer[Bars-i]=0.0;
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
         TempBuffer[i]=MathMax(high,prevclose)-MathMin(low,prevclose);  // this is the original true-range formula for the MQL4 ATR indicator
         // TempBuffer[i]=MathMax(MathAbs(low-prevclose),MathMax(high-low,MathAbs(high-prevclose)));   // this formula taken from NT7 ATR
        }
      i--;
     }
//----
   if(counted_bars>0) counted_bars--;

   int limit=Bars-counted_bars;
   //for(i=1; i<limit; i++)
      // AtrBuffer[i]=iMAOnArray(TempBuffer,Bars,AtrPeriod,0,MODE_SMA,i);  // this is the original true-range formula for the MQL4 ATR indicator

//   for(i=1; i<limit; i++)
  //     AtrBuffer[i]=iMAOnArray(TempBuffer,Bars,AtrPeriod,0,MODE_SMMA,i);  // this is the smoothed average proposed by jjc

   for(i=limit-1; i>=0; i--)  // must count down so that ATRBuffer[i+1] exists when ATRBuffer[i] is evaluated
      AtrBuffer[i] = (((AtrPeriod-1)*AtrBuffer[i+1])+TempBuffer[i])/AtrPeriod;   // this formula taken from NT7 ATR and suggested by tradeboy

//----
   return(0);
  }
//+------------------------------------------------------------------+